/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


// objet Communication
var go_communication;

// zone de datation
var go_dateCommunication;

/**
 * Initialisation de l'overlay
 * 
 * @param {int} id_communication    identifiant de communication
 * @param {String} mode             mode de la fiche
 */
function init_communication(id_communication, mode) {
	try {
        go_communication = new Communication();
        go_dateCommunication = new DateHeureWidget("jour_communication", "mois_communication",
                                                   "annee_communication", "heure_communication",
                                                   "minute_communication");
        
        if (id_communication == null || id_communication == 0 || id_communication == undefined) 
            mode_communication = "N";
        else {
            go_communication.Id_Communication = id_communication;
            mode_communication = mode;
        }
        
        chargerInfosCommunication();

        try {
            var items = document.getElementById("liste_canaux").menupopup.childNodes;
            document.getElementById("liste_canaux").value = go_communication.Id_Canal;
            document.getElementById("liste_initiateurs").value = go_communication.Id_Initiateur;
        } catch (e) {
            // charger les listes _aprs_ avoir rcupr les valeurs d'identifiants
            load_rdf_async("liste_canaux",
                     getUrlOpeneas("&Page=CRM/GetRDF/listeCanaux.tmpl&ContentType=xml"), 
                     function() {
                         document.getElementById("liste_canaux").value = go_communication.Id_Canal;
                     });
            load_rdf_async("liste_initiateurs", 
                     getUrlOpeneas("&Page=CRM/GetRDF/listeInitiateurs.tmpl&ContentType=xml"),
                     function(){
                        document.getElementById("liste_initiateurs").value = go_communication.Id_Initiateur;
                     });
        } 
        
        identifiant_communication = go_communication.Id_Communication; // met l'id  0 ou valeur > 0
	} catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#init_communication : '+ e);
    }
}

/**
 * Charger les infos de la communication si ncessaire
 * 
 */
function chargerInfosCommunication() {
    try {
        if (mode_communication == "M" || mode_communication == "L") {
            finChargerInfosCommunication(go_communication.selectionner());
            if (mode_communication == "L") {
                disableAll();
            }
        } else {
            var req_prospect = new QueryHttp("CRM/Prospects/selectionnerProspect.tmpl");
            req_prospect.setParam("Id_Prospect", ParamValeur("Id_Prospect"));
            req_prospect.execute(finChargerNouvelleCommunication);
        }
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_communication.js#chargerInfosCommunication : "+ e);
    }
}

/**
 * Charger la fentre avec les donnes de la communication
 * 
 * @param {XMLHttpRequest} req requte de chargerInfosCommunication
 */
function finChargerInfosCommunication(req) {
    try {
        var com = req.responseXML.documentElement;
        
        document.getElementById("txtIdTiers").value = com.getAttribute("Id_Prospect");
        document.getElementById("txtRaisonSocialeTiers").value = com.getAttribute("Raison_Sociale");
        document.getElementById("txtCommentaireCommunication").value = com.getAttribute("Commentaire_Communication");
        document.getElementById("lblCreateurCommunication").value = com.getAttribute("Createur");
        var date_com = com.getAttribute("Date_Communication");
        document.getElementById("jour_communication").value = date_com.substr(0, 2);
        document.getElementById("mois_communication").value = date_com.substr(3, 2);
        document.getElementById("annee_communication").value = date_com.substr(6, 4);
        document.getElementById("heure_communication").value = date_com.substr(11, 2);
        document.getElementById("minute_communication").value = date_com.substr(14, 2);

        go_communication.Id_Canal = com.getAttribute("Id_Canal");
        go_communication.Id_Initiateur = com.getAttribute("Id_Initiateur");
        go_communication.Id_Prospect = com.getAttribute("Id_Prospect");
        
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#finChargerInfosCommunication : '+ e);
    }
}

/**
 * Charger la fentre avec les donnes pour une nouvelle communication
 * 
 * @param {XMLHttpRequest} req requte de chargerInfosCommunication
 */
function finChargerNouvelleCommunication(req) {
    try {
        var tiers = req.responseXML.documentElement;
        document.getElementById("txtIdTiers").value = tiers.getAttribute("Id_Prospect");
        document.getElementById("txtRaisonSocialeTiers").value = tiers.getAttribute("Raison_Sociale");
        document.getElementById("txtCommentaireCommunication").value = "";
        go_dateCommunication.setAujourdhui();
        // fixer les valeurs de l'objet pour que les listes s'initialisent.
        go_communication.Id_Canal = 1;
        go_communication.Id_Initiateur = 1;
        document.getElementById("liste_canaux").value = 1;
        document.getElementById("liste_initiateurs").value = 1;
        document.getElementById("bNouvelleCommunication").disabled = true;
        document.getElementById("bSupprimerCommunication").disabled = true;
        document.getElementById("bAjouterResolution").disabled = true;
        var util = new QueryHttp("Utilisateurs/getUtilisateur.tmpl");
        util.setParam("Utilisateur_Id", get_cookie("User"));
        var retour = util.execute();
        document.getElementById("lblCreateurCommunication").value = retour.responseXML.documentElement.getAttribute("Login");
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#finChargerNouvelleCommunication : '+ e);
    }
}
/**
 * Mettre tous les champs en 'disabled', en lecture seule
 */
function disableAll() {
    document.getElementById("txtIdTiers").disabled = true;
    document.getElementById("txtRaisonSocialeTiers").disabled = true;
    go_dateCommunication.disable();
    document.getElementById("txtCommentaireCommunication").disabled = true;
    document.getElementById("liste_canaux").disabled = true;
    document.getElementById("liste_initiateurs").disabled = true;
}

/**
 * Prparer les champs pour une nouvelle communication
 */
function nouvelleCommunication() {
    if (mode_communication == "M") { // on ne fait rien si en lecture
        
        go_dateCommunication.enable();
        document.getElementById("txtCommentaireCommunication").disabled = false;
        document.getElementById("liste_canaux").disabled = false;
        document.getElementById("liste_initiateurs").disabled = false;
        document.getElementById("overlay_resolution").collapsed = true;
        
        var req_prospect = new QueryHttp("CRM/Prospects/selectionnerProspect.tmpl");
        req_prospect.setParam("Id_Prospect", ParamValeur("Id_Prospect"));
        req_prospect.execute(finChargerNouvelleCommunication);
        
        identifiant_communication = 0;
        identifiant_resolution_communication = 0;
        go_communication.setDefauts();
        mode_communication = "N";
    }
}

/**
 * Ajouter une rsolution  cette communication
 */
function ajouterResolution() {
    try {
        disableAll();
        document.getElementById("overlay_resolution").collapsed = false;
        document.getElementById("bSupprimerCommunication").disabled = true;
        document.getElementById("bEnregistrerCommunication").disabled = true;
        document.getElementById("bAjouterResolution").disabled = true;
        nouvelleResolution();
        window.sizeToContent();
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#ajouterResolution : '+ e);
    }
}

/**
 * Enregistrer une communication paramtre
 */
function enregistrerCommunication() {
    try {
        go_communication.Mode = mode_communication;
        go_communication.Id_Prospect = ParamValeur("Id_Prospect");
        go_communication.Id_Canal = document.getElementById("liste_canaux").value;
        go_communication.Id_Initiateur = document.getElementById("liste_initiateurs").value;
        go_communication.Commentaire_Communication = document.getElementById("txtCommentaireCommunication").value;
        go_communication.Date_Communication = go_dateCommunication.getPlanning();
        
        try {
            go_communication.verifier();
            finEnregistrementCommunication(go_communication.enregistrer());
        } catch (e if e == 'DateFormatException') {
            showWarning("Date de communication incorrecte.");
            document.getElementById('bEnregistrerCommunication').disabled = false;
			document.getElementById('bSupprimerCommunication').disabled = false;
        }
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#enregistrerCommunication : '+ e);
    }
}

/**
 * Finaliser l'enregistrement de la communication
 * @param {XMLHttpRequest} req resultat d'une requte QueryHttp
 */
function finEnregistrementCommunication(req) {
    try {
        var reponse = req.responseXML.documentElement;
        var message = reponse.getAttribute("code");
        
        if (message == "echec")
            showWarning("Echec de l'enregistrement.");
        else {
            showMessage("La communication est correctement enregistr\u00E9e.");
            document.getElementById("bSupprimerCommunication").disabled = false;
            document.getElementById("bAjouterResolution").disabled = false;
            
            mode_communication = "M";
            identifiant_communication = reponse.getAttribute("Id_Communication");
            // paramtrer l'identifiant de communication dans la rsolution
            identifiant_resolution_communication = identifiant_communication;
        }
        document.getElementById("bNouvelleCommunication").disabled = false;
        document.getElementById("bEnregistrerCommunication").disabled = false;
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_communication.js#finEnregistrementCommunication : '+ e);
    }
}

/**
 * Supprimer la communication affiche
 */
function supprimerCommunication() {
    try {
        if (mode_communication == "M" &&
        confirm("Supprimer cette communication ?")) {
            go_communication.Id_Communication = identifiant_communication;
            var req = go_communication.supprimer();
            if (req.responseXML.documentElement.getAttribute("code") == "succes") {
                showMessage("Communication et r\u00E9solutions supprim\u00E9es");
                resetCommunication();
            }
            else 
                showWarning("Echec de la suppression.");
        } 
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_communication.js#supprimerCommunication : "+ e);
    }
}

/**
 * Mettre la fiche en tat vierge
 */
function resetCommunication() {
    try {
        go_communication.setDefauts();
        identifiant_communication = 0;
        identifiant_resolution_communication = 0;
        mode_communication = "N";
        
        go_dateCommunication.setAujourdhui();
        // fixer les valeurs de l'objet pour que les listes s'initialisent.
        document.getElementById("liste_canaux").value = 1;
        document.getElementById("liste_initiateurs").value = 1;
        document.getElementById("txtCommentaireCommunication").value = "";
        
        document.getElementById("txtCommentaireCommunication").disabled = false;
        document.getElementById("liste_canaux").disabled = false;
        document.getElementById("liste_initiateurs").disabled = false;
        go_dateCommunication.enable();
        document.getElementById("bNouvelleCommunication").disabled = true;
        document.getElementById("bSupprimerCommunication").disabled = true;
        document.getElementById("bAjouterResolution").disabled = true;
        document.getElementById("bEnregistrerCommunication").disabled = false;
        
        resetResolution();
        document.getElementById("overlay_resolution").collapsed = true;
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_communication.js#resetCommunication : "+ e);
    }
}