/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

// objet Resolution
var go_resolution;

// identifiant de communication stock
var identifiant_resolution_communication;

// objet de zone de planning
var go_planningEvenement;

/**
 * Initialisation de l'overlay
 */
function init_resolution(id_resolution, id_communication, mode) {
	try {
        go_resolution = new Resolution();
        go_planningEvenement = new DateHeureWidget("jour_evenement", "mois_evenement",
                                                   "annee_evenement", "heure_evenement",
                                                   "minute_evenement");
        
        if (id_resolution == null || id_resolution == 0 || id_resolution == undefined) 
            mode_resolution = "N";
        else {
            go_resolution.Id_Resolution = id_resolution;
            mode_resolution = mode;
        }
        
        chargerInfosResolution();
        
        try {
            var items = document.getElementById("liste_priorites").menupopup.childNodes;
            document.getElementById("liste_priorites").value = go_resolution.Id_Priorite;
            document.getElementById("liste_evenements").value = go_resolution.Id_Evenement;
            document.getElementById("liste_responsables").value = go_resolution.Util_R;
            document.getElementById("liste_statuts").value = go_resolution.Id_Statut;
        } catch (e) {
            // charger les listes _aprs_ avoir rcupr les valeurs d'identifiants
            load_rdf_async("liste_evenements", 
                    getUrlOpeneas("&Page=CRM/GetRDF/listeEvenements.tmpl&ContentType=xml"),
                    function() {
                        document.getElementById("liste_evenements").value = go_resolution.Id_Evenement;
                    });
            load_rdf_async("liste_priorites",
                     getUrlOpeneas("&Page=CRM/GetRDF/listePriorites.tmpl&ContentType=xml"),
                     function() {
                        document.getElementById("liste_priorites").value = go_resolution.Id_Priorite;
                     });
            load_rdf_async("liste_responsables",
                    getUrlOpeneas("&Page=CRM/GetRDF/listeResponsables.tmpl&ContentType=xml"),
                    function() {
                        document.getElementById("liste_responsables").value = go_resolution.Util_R;
                    });
            load_rdf_async("liste_statuts",
                    getUrlOpeneas("&Page=CRM/GetRDF/listeStatuts.tmpl&ContentType=xml"),
                    function() {
                        document.getElementById("liste_statuts").value = go_resolution.Id_Statut;
                    });
            document.getElementById("liste_evenements").insertItemAt(0, "Aucun", "0");
        }
        
        identifiant_resolution = go_resolution.Id_Resolution;
        identifiant_resolution_communication = id_communication;
        
	} catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#init_resolution : '+ e);
    }
}

/**
 * Charger les infos de la rsolution si ncessaire
 * 
 */
function chargerInfosResolution() {
    try {
        if (mode_resolution == "M")
            finChargerInfosResolution(go_resolution.selectionner());
        else {
            go_resolution.Id_Priorite = 1;
            go_resolution.Id_Evenement = 0;
            go_resolution.Util_R = get_cookie('User');
            go_resolution.Id_Statut = 1;
            sansEvenement();
        }
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_resolution.js#chargerInfosResolution : "+ e);
    }
}

/**
 * Charger la fentre
 * 
 * @param {XMLHttpRequest} req requte de chargerInfosCaissier
 */
function finChargerInfosResolution(req) {
    try {
        var reso = req.responseXML.documentElement;
        
        document.getElementById("txtDescriptionResolution").value = reso.getAttribute("Description_Resolution");
        // fixer les attributs de go_resolution pour les valeurs de liste
        go_resolution.Id_Statut = reso.getAttribute("Id_Statut");
        go_resolution.Id_Priorite = reso.getAttribute("Id_Priorite");
        go_resolution.Util_R = reso.getAttribute("Util_R");
        
        var id_ev = reso.getAttribute("Id_Evenement");
        if (id_ev == 0) 
            sansEvenement();
        else {
            var date_ev = reso.getAttribute('Date_Evenement'); // format jj/mm/aaaa/hh/mm ou entier 1
            if (date_ev == 1) {
                document.getElementById("chkEvenementResolution").checked = true;
                go_planningEvenement.setDateHeure("", "", "", "", "");
            } else {
                document.getElementById("chkEvenementResolution").checked = false;
                // on obtient une date au format jj/mm/aaaa/hh/mm
                go_planningEvenement.setDateHeure(date_ev.substr(0, 2),
                                                  date_ev.substr(3, 2),
                                                  date_ev.substr(6, 4),
                                                  date_ev.substr(11, 2),
                                                  date_ev.substr(14, 2));
            }
        }
        go_resolution.Id_Evenement = id_ev;
        go_resolution.Date_Evenement = date_ev;
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#finChargerInfosResolution : '+ e);
    }
}

function selectionnerEvenement() {
    try {
        // nettoyer les champs de datation/excution
        resetDatationExecution();
        if (document.getElementById("liste_evenements").value == 0) {
            document.getElementById("executionEvenementResolution").collapsed = true;
            document.getElementById("dateEvenementResolution").collapsed = true;
            document.getElementById("heureEvenementResolution").collapsed = true;
        } else {
            document.getElementById("executionEvenementResolution").collapsed = false;
            document.getElementById("dateEvenementResolution").collapsed = false;
            document.getElementById("heureEvenementResolution").collapsed = false;
        }
        window.sizeToContent();
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#selectionnerResolution : '+ e);
    }
}

/**
 * Prparer la fiche pour une nouvelle rsolution
 */
function nouvelleResolution() {
    try {
        mode_resolution = "N";
        resetResolution();
    } catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#nouvelleResolution : '+ e);
    }
}

/**
 * Enregistrer/modifier la rsolution
 */
function enregistrerResolution() {
    try {
        go_resolution.Mode = mode_resolution;
        go_resolution.Id_Resolution = identifiant_resolution;
        go_resolution.Id_Evenement = document.getElementById("liste_evenements").value;
        go_resolution.Id_Priorite = document.getElementById("liste_priorites").value;
        go_resolution.Id_Statut = document.getElementById("liste_statuts").value;
        go_resolution.Util_R = document.getElementById("liste_responsables").value;
        go_resolution.Description_Resolution = document.getElementById("txtDescriptionResolution").value;
        go_resolution.Id_Communication = identifiant_resolution_communication;
        
        if (document.getElementById("chkEvenementResolution").checked &&
        go_planningEvenement.estDateHeure()) 
            showWarning("Choisissez un mode : pour ex\u00E9cution, ou datation, pas les deux !");
        else {
            document.getElementById('bEnregistrerResolution').disabled = true;
			document.getElementById('bSupprimerResolution').disabled = true;
            try {
                go_resolution.Date_Evenement = (document.getElementById("chkEvenementResolution").checked ? 1 : go_planningEvenement.getPlanning());
                go_resolution.verifier();
                finEnregistrementResolution(go_resolution.enregistrer());
            } catch (e if e == 'DateFormatException') {
                showWarning("Date d'vnement incorrecte.");
                document.getElementById('bEnregistrerResolution').disabled = false;
			    document.getElementById('bSupprimerResolution').disabled = false;
            }
        }
    }  catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#enregistrerResolution : '+ e);
    }
}

/**
 * Fonction de rappel aprs l'enregistrement de la rsolution
 * 
 * @param {XMLHttpRequest} req resultat d'une requte QueryHttp
 */
function finEnregistrementResolution(req) {
    try {
    	var message = req.responseXML.documentElement.getAttribute("code");
    	var id_resolution = req.responseXML.documentElement.getAttribute("Id_Resolution");
        
        if (message == "echec")
            showWarning("Echec de l'enregistrement.");
        else {
            showMessage("La r\u00E9solution est correctement enregistr\u00E9e.");
            document.getElementById("bSupprimerResolution").disabled = false;
            mode_resolution = "M";
            identifiant_resolution = id_resolution;
            try {
                rafraichirHistoriqueCommunications();
            } catch (e) {} // si on ne vient pas d'un overlay de l'assistant
        }
        document.getElementById("bEnregistrerResolution").disabled = false;
    } catch (e) {
	    recup_erreur('erreur dans crm/user/communications/overlay_resolution.js#finEnregistrementResolution : '+ e);
    }
}

/**
 * Supprimer la rsolution affiche
 */
function supprimerResolution() {
    try {
        if (mode_resolution == "M" && 
            confirm("Supprimer cette r\u00E9solution ?")) {
                go_resolution.Id_Resolution = identifiant_resolution;
                var req = go_resolution.supprimer();
                if (req.responseXML.documentElement.getAttribute("code") == "succes") {
                    showMessage("R\u00E9solution supprim\u00E9e.");
                    identifiant_resolution = 0;
                    go_resolution.Id_Resolution = 0;
                    rafraichirHistoriqueCommunications();
                    resetResolution();
                } else 
                    showWarning("Echec de la suppression.");
                /* On ne revient pas au prospect car l'overlay servira
                 * sur une autre configuration
                 */
        } 
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_resolution.js#supprimerResolution : "+ e);
    }
}

/**
 * Mettre la fiche dans un tat sans vnement
 */
function sansEvenement() {
    resetDatationExecution();
    document.getElementById("liste_evenements").value = 0;
    document.getElementById("executionEvenementResolution").collapsed = true;
    document.getElementById("dateEvenementResolution").collapsed = true;
    document.getElementById("heureEvenementResolution").collapsed = true;
}

/**
 * Mettre  blanc les champs de datation (date et heure) et excution (case  cocher)
 */
function resetDatationExecution() {
    go_planningEvenement.setDateHeure("", "", "", "", "");
    document.getElementById("chkEvenementResolution").checked = false;
}

/**
 * Mettre la fiche en tat vierge
 */
function resetResolution() {
    try {
        go_resolution.setDefauts();
        
        sansEvenement(); // fait un reset des champs de date/heure
        document.getElementById("liste_priorites").value = 1;
        document.getElementById("liste_responsables").value = get_cookie("User");
        document.getElementById("liste_statuts").value = 1;
        document.getElementById("txtDescriptionResolution").value = "";
        document.getElementById("bSupprimerResolution").disabled = true;
    } catch (e) {
	    recup_erreur("erreur dans crm/user/communications/overlay_resolution.js#resetResolution : "+ e);
    }
}
