/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/* on stocke ici les identifiants et les modes
 * pour permettre leur redfinition lors d'une autre
 * utilisation des overlays
 */
// identifiant de rsolution stock
var identifiant_resolution = null;
// identifiant stock de communication
var identifiant_communication = null;
// modes : M pour modification, N pour nouvelle fiche, L pour lecture seule
var mode_resolution = "M";
var mode_communication = "M";

/**
 * Initialisation de l'overlay
 * 
 * @param {int} id_resolution           identifiant de la rsolution
 * @param {int} id_communication        identifiant de la communication
 * @param {int} mode_communication      mode de la fiche en communication
 */
function init_resolution_communication(id_resolution, id_communication, mode_communication) {
	try {
        init_communication(id_communication, mode_communication);
        init_resolution(id_resolution, id_communication, "M");
        /* En lecture seule, on affiche la communication en lecture, mais pas les boutons
         * Mais en mode "Nouvelle communication" on affiche uniquement la communication pour l'instant
         */ 
        document.getElementById("box_gestion_communication").collapsed = (mode_communication == "L");
        document.getElementById("overlay_resolution").collapsed = (mode_communication != "L");
	} catch (e) {
        recup_erreur('erreur dans crm/user/communications/overlay_resolution_comunication.js#init_resolution_communication : '+ e);
    }
}


