/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * @classDescription Un observateur pour l'onglet Rendez-vous de l'assistant
 * @return {Object} retourne un nouvel objet AssistantRdv
 * @constructor
 * @inherits AssistantObservateur
 * @param {Object} id    identifiant de l'objet observateur
 */
function AssistantRdv(id) {
    AssistantObservateur.call(this, id);
    this.planningRdv = new DateHeureWidget("jour_rdv", "mois_rdv", "annee_rdv",
                                           "heure_rdv", "minute_rdv");
}

heriter(AssistantObservateur.prototype, AssistantRdv.prototype);

AssistantRdv.prototype.enregistrer = function(prospect) {
    prospect.Date_Rdv = this.planningRdv.getPlanning();
}

AssistantRdv.prototype.reset = function() {
    this.planningRdv.setDateHeure("", "", (new Date()).getFullYear(), "", "00");
}

AssistantRdv.prototype.init = function() {
    this.reset();
    document.getElementById("jour_rdv").focus();
}

// cration de l'observateur qui s'enregistre automatiquement
go_assistant_rdv = new AssistantRdv("overlay_rdv");
ajouterObservateur(go_assistant_rdv);


