/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

// arbre des rsultats
var ga_planning = new Arbre('crm', 'planningPhoning.tmpl', 'planning');

/**
 * Initialisation de la fentre
 */
function init(){
    document.getElementById("rgpContactClient").disabled = true;
    document.getElementById("rgpOrdreTri").disabled = true;
    document.getElementById("rgpChampTri").disabled = true;
}

/**
 * Activer les zones de tri
 */
function activerOrdreTri() {
    try {
	    var action = false;
        
        if (!document.getElementById("chkOrdreTri").checked) {
            action = true;
            document.getElementById("rgpOrdreTri").selectedIndex = -1;
            document.getElementById("rgpChampTri").selectedIndex = -1;
        }
        document.getElementById("rgpOrdreTri").disabled = action;
        document.getElementById("rgpChampTri").disabled = action;
    } catch (e) {
    	recup_erreur('erreur dans crm/user/phoning/planning_phoning.js#activerOrdreTri : ' + e);
    }
}

/**
 * Activer la slection contact client
 */
function ouvrirContactClient() {
    var action = false;
    if (!document.getElementById("chkContactClient").checked) {
        action = true;
        document.getElementById("datePrecise").collapsed = true;
        document.getElementById("dateFourchette").collapsed = true;
        document.getElementById("choixDates").collapsed = true;
    }
	document.getElementById("rgpContactClient").disabled = action;
}

/**
 * Afficher le groupe de boutons radio pour le choix des dates
 */
function ouvrirChoixDates() {
	document.getElementById("choixDates").collapsed = false;
}

/**
 * Afficher le/les zones de texte pour le choix de/des date(s)
 */
function ouvrirModeDates(){
    var idx = document.getElementById("rgpModeDates").selectedIndex;
    if (idx <= 1) {
        document.getElementById("datePrecise").collapsed = true;
        document.getElementById("dateFourchette").collapsed = true;
    } else if (idx == 2) {
        document.getElementById("datePrecise").collapsed = false;
        document.getElementById("dateFourchette").collapsed = true;
    }
    else if (idx == 3) {
         document.getElementById("datePrecise").collapsed = true;
         document.getElementById("dateFourchette").collapsed = false;
    }
}

/**
 * Afficher la zone de texte pour le choix de la ville
 */
function ouvrirChoixVille() {
    var action = false;
    if (!document.getElementById("chkVille").checked)
        action = true;
	document.getElementById("choixVille").collapsed = action;
}

/**
 * Afficher la zone de texte pour le choix de la raison sociale
 */
function ouvrirChoixRaisonSociale() {
    var action = false;
    if (!document.getElementById("chkRaisonSociale").checked)
        action = true;
	document.getElementById("choixRaisonSociale").collapsed = action;
}

/**
 * vrifier les critres de tri
 */
function verifierTri() {
    try {
        var ville = document.getElementById("txtVille").value;
        var rs = document.getElementById("txtRaisonSociale").value;
        var jour = document.getElementById("txtDatePrecise").value;
        var debut_fourchette = document.getElementById("txtDebutFourchette").value;
        var fin_fourchette = document.getElementById("txtFinFourchette").value;
       
        if (document.getElementById("chkVille").checked) {
            if (isEmpty(ville)) {
                showWarning("Veuillez pr\u00E9ciser une ville pour votre recherche");
                return false;
            } else {
                ga_planning.setParam("Ville", ville);
            }
        }
        
        if (document.getElementById("chkRaisonSociale").checked) {
            if (isEmpty(rs)) {
                showWarning("Veuillez pr\u00E9ciser une raison sociale pour votre recherche");
                return false;
            } else {
                ga_planning.setParam("Raison_Sociale", rs);
            }
        }
        
        if (document.getElementById("chkPlaquette").checked)
            ga_planning.setParam("Demande_Plaquette", 1);
            
        if (document.getElementById("chkContactClient").checked) {
            if (!document.getElementById("rgpContactClient").selectedItem) {
                showWarning("Veuillez pr\u00E9ciser un type de contact.");
                return false;
            } else {
                ga_planning.setParam("Contact",
                                     document.getElementById("rgpContactClient").selectedItem.value);
                if (!document.getElementById("rgpModeDates").selectedItem) {
                    showWarning("Veuillez pr\u00E9ciser un type de date pour le contact.");
                    return false;
                }
                var date_contact = document.getElementById("rgpModeDates").selectedItem.value;
                switch (date_contact) {
                    case "jour":
                        if (!isDate(jour)) {
                            showWarning("Veuillez pr\u00E9ciser une date pour la recherche par jour donn\u00E9.");
                            return false;
                        } else
                            ga_planning.setParam("Jour_Contact", prepareDateJava(jour));
                        break;
                    
                    case "fourchette":
                        if (!isDateInterval(debut_fourchette, fin_fourchette)) {
                            showWarning("Veuillez pr\u00E9ciser une fourchette de dates convenable pour la recherche par intervalle.");
                            return false;
                        } else {
                            ga_planning.setParam("Debut_Contact", prepareDateJava(debut_fourchette));
                            ga_planning.setParam("Fin_Contact", prepareDateJava(fin_fourchette));
                        }
                        break;
                        
                    case "aujourdhui":
                        var d = new Date();
                        ga_planning.setParam("Jour_Contact",
                                             d.getFullYear() + ":" + 
                                             (d.getMonth() + 1) + ":" +
                                             d.getDate());
                        break;
                        
                    case "aujourdhui_et_plus":
                        var d = new Date();
                        ga_planning.setParam("Jour_Contact_Posterieur",
                                             d.getFullYear() + ":" + 
                                             (d.getMonth() + 1) + ":" +
                                             d.getDate());
                        break;
                }
            }
        }
        
        if (document.getElementById("rgpOrdreTri").selectedItem && 
            ! document.getElementById("rgpChampTri").selectedItem) {
            showWarning("Veuillez pr\u00E9ciser un champ pour le tri.");
            return false;        
        }
        
        if (document.getElementById("rgpChampTri").selectedItem) {
            ga_planning.setParam("champTri", document.getElementById("rgpChampTri").selectedItem.value);
            if (document.getElementById("rgpOrdreTri").selectedItem)
                ga_planning.setParam("ordreTri", document.getElementById("rgpOrdreTri").selectedItem.value);
        }
        
        return true;
    } catch (e) {
        recup_erreur ('erreur dans crm/user/phoning/planning_phoning.js#verifierTri : '+ e);
    }
}

/**
 * Afficher le planning suivant les critres de tri
 */
function afficherPlanning() {
    try {
        if (verifierTri()) {
            ga_planning.deleteTree();
            ga_planning.initTree();
        }
    } catch (e) {
        recup_erreur('erreur dans crm/user/phoning/planning_phoning.js#afficherPlanning : ' + e);
    } finally {
        ga_planning.clearParams();
    }
}

function afficherFicheProspect() {
    try {
        var tree = document.getElementById("planning");
        if (tree.view != null && tree.currentIndex != -1) {
            var url = "chrome://opensi/content/crm/user/prospects/gestion_prospects.xul?" + cookie();
            url += "&Id_Prospect=" + getCellText(tree, tree.currentIndex, "idProspect");
            window.location = url;
        }
    } catch (e) {
	    recup_erreur("erreur dans crm/user/phoning/planning_phoning.js#retourMenuPrincipal : "+ e);
    }
}
/**
 * Revenir au menu principal de facturation
 */
function retourMenuPrincipal() {
    try {
	    window.location = "chrome://opensi/content/crm/user/menu_crm.xul?" + cookie();
    } catch (e) {
	    recup_erreur("erreur dans crm/user/phoning/planning_phoning.js#retourMenuPrincipal : "+ e);
    }
}
