/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package com.ael.crm.metier;

import java.util.Comparator;

/**
 * Classe permettant de comparer deux Prospects sur leur attribut dateRecontact
 * @author jm
 */
class ComparateurARecontacter implements Comparator<Prospect> {
	
	/**
	 * Compare deux objets de type Prospect
	 * 
	 * @param prospect	un Object prospect
	 * @param autreProspect		un second Object prospect à comparer au premier
	 * @return 0 si les deux Prospect sont identiques par leur attribut dateRecontact, un entier positif
	 *           ou négatif sinon.
	 */
	public int compare(Prospect prospect, Prospect autreProspect) {
		return  (int) (prospect.getDateRecontact() - autreProspect.getDateRecontact());
	}

}
